<?
/**********************************************************************
File Name:              index.php
Dev:                    Daniele De Santis
Email:                  webmaster@desantix.it
Web:                    http://www.desantix.it

Versione:               0.2
Data:                   10/07/12
Note Hardware:  
Note Software:          PHP 5
**********************************************************************/
@date_default_timezone_set('Europe/Rome');

include "inverter_label.inc.php";
include "setup.php";

define ("DEBUG_ON", 0);

$_APP_NAME = "INVERTER PowerMeterLite";
$_APP_VER = "0.2 beta";


if(empty($_REQUEST[IP]))
  $server_ip = $default_ip;
else
  $server_ip = $_REQUEST[IP];
  
if(empty($_REQUEST[PORT]))
  $server_port = $default_port;
else
  $server_port = $_REQUEST[PORT];
  
if(empty($_REQUEST[ADR]))
  $inverter_address = $default_address;
else
  $inverter_address = $_REQUEST[ADR];
  
  
$CMD_SN  =  chr($inverter_address) . chr(0x3f) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_ST  =    chr($inverter_address) . chr(0x32) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_CET  =   chr($inverter_address) . chr(0x4e) . chr(0x05) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_CED  =   chr($inverter_address) . chr(0x4e) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_DSP3=  chr($inverter_address) . chr(0x3b) . chr(0x03) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00); //DSP Grid Power
$CMD_DSP23= chr($inverter_address) . chr(0x3b) . chr(0x17) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 1 Voltage
$CMD_DSP25= chr($inverter_address) . chr(0x3b) . chr(0x19) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 1 Current
$CMD_DSP26= chr($inverter_address) . chr(0x3b) . chr(0x1A) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 2 Voltage
$CMD_DSP27= chr($inverter_address) . chr(0x3b) . chr(0x1B) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 2 Current
$CMD_VR=    chr($inverter_address) . chr(0x3A) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);

$cmdarray= array("ST"=>$CMD_ST, "CET"=>$CMD_CET, "CED"=>$CMD_CED,"DSP3"=>$CMD_DSP3,"DSP23"=>$CMD_DSP23,"DSP25"=>$CMD_DSP25,"DSP26"=>$CMD_DSP26,"DSP27"=>$CMD_DSP27,"SN"=>$CMD_SN,"VR"=>$CMD_VR);


function PrintHEX($cmd){
  for ( $x=0; $x<strlen($cmd); $x++ ) {
    printf("0x%x ", ord($cmd[$x]));
  }
  print "<br>";
}

function HexToChar($Hex){
  $string="";
  for ($i=0; $i<(strlen($Hex)); $i++) 
    $string .= chr(ord($Hex[$i]));
  return $string;
}

function DSPValue($Hex){
  $v = (ord($Hex[2])<<24) + (ord($Hex[3])<<16) + (ord($Hex[4])<<8) + ord($Hex[5]);
  $x = ($v & ((1 << 23) - 1)) + (1 << 23) * ($v >> 31 | 1);
  $exp = ($v >> 23 & 0xFF) - 127;
  return $x * pow(2, $exp - 23);
}

function CRC($cmd){
  $BccLo=0xFF;
  $BccHi=0xFF;
  for ( $x=0; $x<strlen($cmd); $x++ ) {
    $c = ord($cmd[$x]) ^ $BccLo;
    $tmp=($c << 4) & 0xFF;
    $c=$tmp ^ $c;
    $tmp=($c >> 5) & 0xFF; 
    $BccLo=$BccHi;
    $BccHi= $c ^ $tmp;
    $tmp= ($c << 3) & 0xFF;
    $BccLo= $BccLo ^ $tmp;
    $tmp= ($c >> 4) & 0xFF;
    $BccLo= $BccLo ^ $tmp;
  }
  $CRC_L=~($BccLo) & 0xFF;
  $CRC_H=~($BccHi)& 0xFF;
  return (($CRC_H<<8) & 0xFF00) + (($CRC_L)& 0xFF);
}

function CheckCRC($rxdata){
  $rx_crc = $rxdata[6].$rxdata[7];
  //PrintHEX($rx_crc);
  $my_crc=CRC(substr($rxdata, 0, -2));
  $my_crc=chr(($my_crc & 0xFF)) . chr((($my_crc>>8) & 0xFF));
  //PrintHEX($my_crc);
  if((ord($rx_crc[0])==ord($my_crc[0])) && (ord($rx_crc[1])==ord($my_crc[1]))) return 1;
  return 0;
}

function QueryInverter($server_ip, $server_port, $cmdarray){

  $cmd_crc=CRC($cmd);
  $cmd= $cmd . chr(($cmd_crc & 0xFF)) . chr((($cmd_crc>>8) & 0xFF)); #Appendo il CRC
  $fp = @fsockopen($server_ip, $server_port, $errno, $errstr, 10);
  if (!$fp) {
    return 0;
  }
  if(DEBUG_ON){
    echo "Connessione TCP/IP OK<br>";
  }


  foreach ($cmdarray as $key => $value) {
    $cmd_crc=CRC($value);
    $txcmd= $value . chr(($cmd_crc & 0xFF)) . chr((($cmd_crc>>8) & 0xFF)); #Appendo il CRC
    
    if(DEBUG_ON){
      echo "TX->";
      PrintHEX($txcmd);
      echo "<br>";
    }
    fputs($fp, $txcmd, 10);
    $rxbuff=fread ($fp,8);
    if(DEBUG_ON){
      echo "RX<-";
      PrintHEX($rxbuff);
      echo "<br>";
    }
    if(strlen($rxbuff)==8){
      $$key="";
      if(CheckCRC($rxbuff)){
        global $$key;
        $rxbuff=substr($rxbuff, 0, -2);
        $$key=$rxbuff;
      } else $$key="CRC error";
    }
  }
  fclose($fp);
  return 1;
}


//INTESTAZIONE
echo"<html>";
echo"<title>$_APP_NAME</title>";
echo"<link href=\"./style.css\" rel=\"stylesheet\" type=\"text/css\">";
echo"<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no\">";
echo"<meta http-equiv=\"refresh\" content=\"60\">";
echo"</head>";
echo"<body>";
echo "<div id=\"header\"><img src='images/logo.png'></div>";





if(QueryInverter($server_ip, $server_port, $cmdarray)){
  $Version        = $VersionPart1_Label[substr($VR, 2, 1)];
  $GlobalState    = ord($ST[2]);
  $InverterState  = ord($ST[3]);
  $AlarmState     = ord($ST[6]);
  $AlarmCODE = $AlarmState_Label[$AlarmState][1];
  if(strlen($AlarmCODE)) $AlarmCODE = "(CODE: " . $AlarmCODE . ")";
  $CET = (ord($CET[2])<<24) + (ord($CET[3])<<16) + (ord($CET[4])<<8) + ord($CET[5]);
  $CET = ((float)$CET /1000);
  $CED = (ord($CED[2])<<24) + (ord($CED[3])<<16) + (ord($CED[4])<<8) + ord($CED[5]);
  $CED  = ((float)$CED /1000);
  $DSP3 = DSPValue($DSP3);
  $DSP23 = DSPValue($DSP23);
  $DSP25 = DSPValue($DSP25);
  $DSP26 = DSPValue($DSP26);
  $DSP27 = DSPValue($DSP27);
  $PIN=($DSP23*$DSP25)+($DSP26*$DSP27);
  echo"<table width=100% cellspacing=0 cellpadding=0 border=0>";
  echo"<tr><td class=listr colspan=2 >Aggiornamento</td><td class=listbg  > <b>" . date('h:i:s  d/m/y'). "</b></td></tr>";
  echo"<tr><td class=listr colspan=2>Connessione TCP/IP</td><td class=listbg> <b>" . $server_ip . " : " . $server_port . "</b></td></tr>";
  echo"<tr><td colspan=3 class=listhdrlr>Inverter</td></tr>";
  echo"<tr><td rowspan=3 width=50 align=center class=listlr><img src='./images/inverter.png'></td><td class=listr width=50%>Modello:</td><td class=listbg width=50%><b>" . $Version . "</b></td></tr>";
  echo"<tr><td class=listr>Seriale:</td><td class=listbg><b>" . HexToChar($SN) . "</b></td></tr>";
  printf("<tr><td class=listr>Indirizzo:</td><td class=listbg><b>0x%02X</b></td></tr>", $inverter_address);
  echo"<tr><td colspan=3 class=listhdrlr>Stato</td></tr>";
  echo"<tr><td colspan=2 class=listr>Globale:</td><td class=listbg><b>".$GlobalState_Label[$GlobalState]."</b></td></tr>";
  echo"<tr><td colspan=2 class=listr>Inverter:</td><td class=listbg><b>".$InverterState_Label[$InverterState]."</b></td></tr>";
  echo"<tr><td colspan=2 class=listr>Allarme:</td><td class=listbg><b>".$AlarmState_Label[$AlarmState][0]." " .$AlarmCODE . "</b></td></tr>";
  echo"<tr><td colspan=3 class=listhdrlr>Potenza</td></tr>";
  printf("<tr><td colspan=2 class=listr>Potenza di Uscita:</td><td class=listbg><b>%.02f W</b></td></tr>", $DSP3);
  printf("<tr><td colspan=2 class=listr>Potenza di Ingresso:</td><td class=listbg><b>%.02f W</b></td></tr>", $PIN);
  echo"<tr><td colspan=3 class=listhdrlr>Produzione</td></tr>";
  printf("<tr><td rowspan=2 align=center class=listlr><img src='./images/counter.png'></td><td class=listr>Produzione Totale:</td><td class=listbg><b>%.02f KWh</b></td></tr>", $CET);
  printf("<tr><td class=listr>Produzione Giornaliera:</td><td class=listbg><b>%.02f KWh</b></td></tr>", $CED);
} else {
  echo"<center><table width=70% cellspacing=0 cellpadding=0 border=0>";
  echo "<tr><tdalign=center ><br></td></tr>";
  echo"<tr><td class=listbg align=center height=100><br><br>ERRORE - Connessione con l'inverter fallita<br><br>Indirizzo IP: " . $server_ip . " Porta TCP/IP: " . $server_port . "<br><br></td></tr></center>";
  
}


echo"<table>";
echo "<div id=pagefooter>
$_APP_NAME ver $_APP_VER<br>Dev By DeSantiX.iT   
</div>";


  
?>
